#version 120

uniform sampler2D gcolor;
uniform float far;
uniform int isEyeInWater;
uniform vec3 fogColor;

varying vec2 texcoord;
varying vec4 position;

const float fogStart = 0.2;
const float fogEnd = 0.5;

void main() {
    vec4 color = texture2D(gcolor, texcoord);

    // Fog calculation
    float dist = length(position.xyz);
    float fogFactor = clamp((dist - far * fogStart) / (far * (fogEnd - fogStart)), 0.0, 1.0);
    vec3 fogColorFinal = isEyeInWater == 1 ? vec3(0.0, 0.1, 0.2) : fogColor; // Underwater fog color

    // Apply fog
    color.rgb = mix(color.rgb, fogColorFinal, fogFactor);

    gl_FragColor = color;
}
