#version 120
#include "/settings/lib.h"



attribute vec4 mc_Entity;

uniform mat4 gbufferModelView;
uniform mat4 gbufferModelViewInverse;
uniform float frameTimeCounter;
uniform vec3 sunPosition;
uniform vec3 cameraPosition;

varying float isPlant;
varying float isOre;
varying vec2 lmcoord;
varying vec2 texcoord;
varying vec3 cPos; //Chunked Position
varying vec3 wPos; //World Position
varying vec3 sunPos; //Sun Position
varying vec3 normal;
varying vec4 position;
varying vec4 glcolor;
//*-*-Main-*-*
void main() {
    isPlant = 0.;
    isOre = 0.;

    gl_Position = ftransform();

    texcoord = (gl_TextureMatrix[0] * gl_MultiTexCoord0).xy;
    lmcoord = (gl_TextureMatrix[1] * gl_MultiTexCoord1).xy;
    glcolor = gl_Color;
    normal = gl_NormalMatrix * gl_Normal;

    float e = mc_Entity.x;
    if (e == 141. || e == 142. || e == 59. || e == 106. || e == 127. || e == 175. || e == 83. || e == 32. || e == 37. || e == 38. || e == 31. || e == 115. || e == 6. || e == 39. || e == 40. || e == 104. || e == 105.) isPlant = 1.;
    if (e == 56. || e == 73. || e == 129. || e == 14. || e == 15. || e == 21. || e == 79.) isOre = 1.;

    // Additional ore check from the new code
    if (mc_Entity.x == 11116 || mc_Entity.x == 11117 || // Diamond Ore
        mc_Entity.x == 11118 || mc_Entity.x == 11119 || // Emerald Ore
        mc_Entity.x == 11120 || mc_Entity.x == 11121 || // Gold Ore
        mc_Entity.x == 11122 || mc_Entity.x == 11123 || // Lapis Ore
        mc_Entity.x == 11124 || mc_Entity.x == 11125 || // Redstone Ore Unlit
        mc_Entity.x == 11128 || mc_Entity.x == 11129 || // Redstone Ore Lit
        mc_Entity.x == 11132 || mc_Entity.x == 11133 || // Iron Ore
        mc_Entity.x == 11136 || mc_Entity.x == 11137) { // Copper Ore
        isOre = 1.;
    }

    sunPos = (vec4(sunPosition, 1.) * gl_ModelViewMatrix).xyz;
    vec4 pos = gbufferModelViewInverse * gl_ModelViewMatrix * gl_Vertex;
    cPos = pos.xyz + cameraPosition;

    #ifdef WAVE
    float wind = cos(frameTimeCounter * 0.3 + cPos.x * 0.02 + cPos.y * 0.04 + cPos.z * 0.002);
    if (isPlant > 0.5) pos.xz += cos(frameTimeCounter * 4. + dot(cPos, vec3(3.2, 1.2, 1.6))) * 0.02 * wind * lmcoord.y; //Grasses, flowers, and other
    if (e == 18. || e == 161.) pos.xz += cos(frameTimeCounter * 4. + dot(cPos, vec3(1.2, 0., 0.6))) * 0.02 * wind * lmcoord.y; //Leaves
    #endif

    wPos = pos.xyz;
    position = gl_ModelViewMatrix * gl_Vertex;

    gl_Position = gl_ProjectionMatrix * gbufferModelView * pos;
}
